$(function() {
	// 当前用户头像显示延迟处理
	var cu_timeout = 0;
	
	// 绑定事件语法糖
	$.fn.wb = function(obj) {
		for (var event in obj) {
			for (var selector in obj[event]) {
				$(this).delegate(selector, event, obj[event][selector]);
			}
		}
	};

	// 滚动事件
	$(window).scroll(function() {
		var scroll_top = $(window).scrollTop();
		if (scroll_top > 700) {
			$("#totop").fadeIn();
		} else {
			$("#totop").fadeOut();
		}
		if ($('#scroll_box').length > 0) {
			var sb_top = $('#scroll_box').offset().top;
			if (sb_top < scroll_top) {
				$('#scroll_box .slide-box-scroll').addClass('follow');
			} else {
				$('#scroll_box .slide-box-scroll').removeClass('follow');
			}
		}
	});

	// 公告滚动
	var wpgo_notice = {
			slide: function() {
				var notice_index = 0;
				var per_time = 2;
				var notice_count = $('.sb-notice-nav span').length;
				var notice_timmer = setInterval(auto_run, per_time * 1000);
				function auto_run() {
					$('.sb-notice-nav span').eq(notice_index).addClass('on').siblings().removeClass('on');
					$('.sb-notice-wrap li').eq(notice_index).fadeIn('slow').siblings().fadeOut('slow');
					notice_index = notice_index == notice_count - 1 ? 0 : notice_index + 1;
				}
				$('.sb-notice').hover(function() {
					clearInterval(notice_timmer);
				}, function(){
					notice_timmer = setInterval(auto_run, per_time * 1000);
				});
				$('.sb-notice-nav span').hover(function() {
					var index = $(this).index();
					$(this).addClass('on').siblings().removeClass('on');
					$('.sb-notice-wrap li').stop().eq(index).show().siblings().hide();
				}, function() {
					notice_index = $(this).index();
				});
			},
			init: function() {
				this.slide();
			}
	};
	
	// 加载公告滚动
	wpgo_notice.init();

	// 状态类文章
	$('.home-post .icon-status').tooltip({placement:'top'});

	// 评论表单获得焦点
	function commentInputFocus() {
		var placeholder = $(this).attr('placeholder');
		var val = $(this).val();
		if(val == placeholder) {
			$(this).val('').css('color','#444').attr('placeholder', '');
			$(this).attr('data-holder', placeholder);
		}
	}
	// 评论表单失去焦点
	function commentInputBlur() {
		var palceholder = $(this).attr('data-holder');
		var default_val = this.defaultValue;
		if (palceholder == $(this).val() || $(this).val() == '') {
			$(this).attr('placeholder',palceholder).val(default_val);
			$(this).removeAttr('style');
		}
	}
	
	// 提交评论时的文字提示
	function comment_ajx_msg(info, status) {
		$('#reply-submit-msg').remove();
		var msg = '<div id="reply-submit-msg"><span class="'+status+'">'+info+'</span></div>';
		$('.comment-form-submit').append(msg);
		$('#reply-submit-msg').slideDown();
		setTimeout(function() {
			$('#reply-submit-msg').slideUp('normal', function() {
				$(this).remove();
			});
		}, 5000);
	}
	
	// 跳转锚点
	function body_am(id, act) {
		id = isNaN (id) ? $('#'+id).offset().top : id;
		$("body,html").animate( {scrollTop: id}, act ? 0 : 500 );
		return false;
	}
	
	// 提交评论前验证
	function check_submit() {
		var flag = check_input();
		if (flag == false) {
			return false;
		}

		// 是否有填写网址
		var url = $('#reply-url');
		if(url.attr('placeholder') == url.val()) {
			url.val('');	
		}
		$('#v_code').val('wpgo');
		$.ajax({
			url: location.origin + '/wp-content/themes/wpgo/wpgo-ajax-comment.php',
			dataType: 'json',
			data : $('#reply-from').serialize(),
			type: 'POST',
			timeout: 15000,
			beforeSend: function() {
				comment_ajx_msg('评论提交中','send');
			},
			error: function(request) {
				var err = request.responseText;
				err = err !== undefined ? err.match(/<p>(.*)<\/p>/)[1] : '服务器响应超时，请重新提交';
				comment_ajx_msg(err,'error');
			},
			success: function(data) {
				if(data.status == 1) {
					// 如果当前文章没有评论，把默认样式删除
					$('.disabled-comment').remove();
					// 再将评论列表显示出来
					$('.comment-list').fadeIn('fast');
					// 如果是回复评论
					if (data.info.indexOf('<ul') == 0) {
						var reply_li_id = $('#reply_li_id').val();
						$('#'+reply_li_id).append(data.info);
						body_am(reply_li_id);
					} else {
						// 否则直接追加到评论列表
						var comment_count = $('#comment_count').text();
						$('#comment_count').text(Number(comment_count) + 1);
						$(data.info).prependTo($('.comment-list').eq(0).children('ul'));
						body_am('comment_count');
					}
					$('#reply-submit-msg').slideUp();
					// 如果不喜欢当前文章并做评论
					if ( $('#wpgo_dislike').val() != '' ) {
						digg_count(false);
						$('#wpgo_dislike').val('');
					}
					$('#reply_comment').val('');
					if (data.is_refresh == '1') {
						var refresh_url = location.href;
						// 处理下IE这个死变态
						var is_ie_url = refresh_url.indexOf('#!');
						if (is_ie_url > 0) {
							refresh_url = refresh_url.substring(is_ie_url + 2);
						}
						wpgo_ajax_load (refresh_url, false);
					}
				} else {
					// 评论失败
					comment_ajx_msg(data.info,'error');
				}
			},
			complete: function() {
				$('#reply-form').fadeOut('fast');
				$('#reply-submit').removeAttr('disabled');
			}
		});
		return false;
	}

	// 验证表单
	function check_input() {
		var flag = true;
		$('.comment-input input').each(function() {
			var input_id = $(this).attr('id');
			var place_text = $(this).attr('placeholder');
			var val = $(this).val();
			var parent = $(this).parent('.cfp');
			if (input_id == 'reply-author') {
				if(val == place_text){
					flag = show_error(parent);
					return false;
				}
			} else if (input_id == 'reply-email') {
				var preg = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
				if (!preg.test($(this).val())) {
					flag = show_error(parent);
					return false;
				}
			} else if (input_id == 'reply-url' && val != '' && val != place_text){
				var preg = /(\w+).(com|com.cn|cn|net|net.cn|name|org|org.cn|cc|me|ml|in|info|tw|tk|so|ru)+/;
				if (!preg.test(val)) {
					flag = show_error(parent);
					return false;
				}
			}
		});

		if (flag == true) {
			var content = $('#reply_comment');
			if ($.trim(content.val()) == '') {
				flag = show_error(content);
			}
		}
		return flag;
	}
	
	// 表单错误提示
	function show_error(input) {
		input.css('background','#FBB')
		.animate({'opacity': 0.5},100)
		.animate({'opacity': 1},100)
		.animate({'opacity': 0.5},100)
		.animate({'opacity': 1},100, function(){ $(this).removeAttr('style'); });
		return false;
	}
	
	// 设置当前导航
	function set_nav_on(url) {
		$('.nav-menu li').each(function() {
			if ($(this).children('a').attr('href') == url) {
				$(this).addClass('current-menu-item').siblings().removeClass('current-menu-item');
				return false;
			}
		});
	}
	
	function create_bookmarks() {
		if (bookmarks) {
			var links = is_home() ? bookmarks['home'] : bookmarks['single'];
			var ret = '';
			for(var i in links) {
				var visible = links[i].link_visible == 'N' ? ' bs-hide' : '';
				var href = links[i].link_url;
				var desc = links[i].link_description;
				var name = links[i].link_name;
				var img = links[i].link_img;
				var target = links[i].link_target;
					target = target == '' ? '_target' : target;
				ret += '<a class="sb-border' + visible + '" href="' + href + '" title="' + desc + '" target="' + target + '"><img src="' + img + '" />' + name + '</a>';
			}
			return ret += '<div class="clr"></div>';
		}
	}
	//是否首页
	function is_home() {
		var lhref = location.href;
		return lhref.substring( 0, lhref.length - 1 ) == homeurl ? true : false;
	}
	
	// Ajax页面加载
	function wpgo_ajax_load(url, state) {
		if (url.indexOf('javascript:') != -1) {
			return false;
		}
		if (is_ajax == 'N') {
			location.href = url;
			return false;
		}
		set_nav_on(url);
		// 不同浏览器的锚点处理
		if (history && history.pushState) {
			(state != true) && history.pushState(null, document.title, url);
		} else {
			// 如果是正常的锚点，则不请求
			if (url.indexOf('#') == 0) {
				return false;
			}
			window.location.hash = '!'+url;
		}

		$.ajax({
			url: url,
			dataType: 'HTML',
			cache: true,
			beforeSend: function() {
				$('<div id="wpgo_ajax_loading_frame"></div><div title="拼命加载页面中..." id="wpgo_ajax_loading"><div></div></div>').appendTo('body');
			},
			timeout: 15000,
			error: function() {
				$('#wpgo_ajax_loading_frame,#wpgo_ajax_loading').remove();
				location.href = url;	//页面错误时跳转到请求的页面
			},
			success: function(data) {
				var content = $(data).find('#left').html();
				(content == '') && (location.href = url);
				var title = data.match(/<title>(.*?)<\/title>/);
				$('#bookmarks').html(create_bookmarks());
				document.title = title ? title[1] : '';
				$('#left').html(content);
				data = content = null;
				SyntaxHighlighter.highlight();
				var anchor = url.indexOf('#');
				if ( anchor == -1 ) {
					body_am(0, true);
				} else {
					anchor = url.substring(anchor+1);
					body_am(anchor, true);
				}
			},
			complete: function() {
				$('#wpgo_ajax_loading_frame,#wpgo_ajax_loading').remove();
			}
		});
	}
	// 全局的事件绑定
	$('#wrap').wb({
		'click': {
			".nav-menu a,.post-header a,.post-info a,.breadcrumb a,.post-thumb a,._ajx,#page-navigation a,#sb-tags a,.related-posts a": function() {
					var url = $(this).attr('href');
					wpgo_ajax_load(url);
					return false;
			},
			// 评论、引用切换
			".comment-tab a": function() {
				var ul_index = $(this).index();
				$('#post-comment-list .comment-list').eq(ul_index).fadeIn('fast').siblings('.comment-list').hide();
				$(this).addClass('current').siblings().removeClass('current');
			},
			// 邮件回复
			"#mail_notify_box": function() {
				if( $(this).hasClass('mail_on') ){
					$(this).removeClass('mail_on');
					$('#reply_mail_notify').val('');
				} else {
					$(this).addClass('mail_on');
					$('#reply_mail_notify').val('Y');
				}
			},
			// 回复按钮
			'.comment-reply-link': function() {
				var parent_id = $(this).attr('href').match(/(\d+)#/);
				$('#comment_parent').val(parent_id[1]);
				var parents = $(this).parents('li');
				var name = parents.children('.comment-avatar').find('a').html();
				var content = parents.find('.comment-connent').html();
				$('#reply_li_id').val($(parents).attr('id'));
				$('#reply-name').html(name);
				$('#reply-content').html(content);
				$('#reply-form').fadeIn('fast');
				$('#reply-text').html($(this).text());
				body_am('reply-form');
			},
			// 取消回复
			'#reply-close': function() {
				$('#comment_parent').val(0);
				$('#wpgo_dislike').val('');
				$('#reply_li_id').val('');
				$('#reply-name').html('');
				$('#reply-form').fadeOut('fast');
			},
			// 提交评论
			'#reply-submit': check_input,
			'.comments_paginate a': function() {
				var current = $(this);
				$.ajax({
					url: current.attr('href'),
					dataType: 'HTML',
					cache: false,
					timeout: 10000,
					beforeSend: function() {
						$('#comments_paginate, #comment_list').fadeOut('slow');
					},
					success: function(data) {
						var content = $(data).find('#comment_list').html();
						var pagedstring = $(data).find('#comments_paginate').html();
						$('#comment_list').html(content);
						$('#comments_paginate').html(pagedstring);
						body_am('post-comment-list');
						$('#comments_paginate, #comment_list').fadeIn('slow');
					},
					error: function() {
						$('#comments_paginate, #comment_list').slideDown('slow','easeOutBack');
					}
				});
				return false;
			},
			// 赞一个
			'#digg_up': function() {
				digg_count(true,true);
				return false;
			},
			// 踩一个
			'#digg_down': function() {
				if($('#reply-form').length > 0) {
					var post_id = $(this).attr('data-pid');
					var url = window.location.href;
					$.get(url, { post_id: post_id, wpgo_action: 'wpgo_check_like' }, function(res){
						if (res == '1') {
							alert('你已经表态过啦');
						} else {
							$('#reply-form').show();
							$('#reply-text').text('给个理由，踩得踏实');
							$('#reply-content').text('给个理由呗，不能踩得不明不白吧？^_^');
							$('#wpgo_dislike').val('Y');
							body_am('reply-form');
						}
					},'text');
				} else {
					digg_count(true,false);
				}
				return false;
			},
			'#sch_btn': function() {
				var val = $('#sch_val').val();
				if (val) {
					var url = $('#sch_form').attr('action') + val;
					wpgo_ajax_load(url);
				}
				return false;
			},
			'.post-title a': function() {
				$(this).text('Loading....');
			},
			'.nav-menu li': function() {
				$(this).addClass('current-menu-item').siblings().removeClass('current-menu-item');
			},
			// 灯箱
			'.post-content img:not(.wp-smiley)': function() {
				var src = $(this).attr('src');
				var img_a = $(this).parent('a');
				var href = img_a.attr('href');
				if (href) {
					var preg = /.*\.[jpg|jpeg|png|gif]+$/;
					if( !preg.test( href ) ) {
						wpgo_ajax_load(href);
						return false;
					} else {
						src = href;
					}
				}
				$.fancybox({
					'href'			: src,
					'autoScale'		: false,
					'titleShow'     : false,
					'transitionIn'	: 'elastic',
					'transitionOut'	: 'elastic',
					'easingIn'      : 'easeOutBack',
					'easingOut'     : 'easeInBack'
				});
				return false;
			},
			'#right .as-year': function() {
				$(this).nextUntil('.as-year').slideToggle(100).css('display','block');
			},
			'#sb_panel .tab-title li': function() {
				$(this).addClass('on').siblings().removeClass('on');
				var index = $(this).index();
				$('#sb_panel .panel').stop().eq(index).slideDown('fast').siblings('.panel').slideUp('fast');
			},
			'#editor_smilies': function() {
				var smilies = $('#smilies_list').html();
				$(this).tooltip( {title:smilies, trigger:'click', html: true } );
			},
			'#editor_img': function() {
				var content = $('#reply_comment').val();
				content += '<img src="图片地址" title="" />';
				$('#reply_comment').val(content);
			},
			'#editor_url': function() {
				var content = $('#reply_comment').val();
				content += '<a href="链接地址" target="_blank" >链接描述</a>';
				$('#reply_comment').val(content);
			},
			'#editor_tools .face': function() {
				var key = $(this).attr('data-key');
				var content = $('#reply_comment').val();
				content += ' '+ key + ' ';
				$('#reply_comment').val(content);
				$('#editor_smilies').trigger('click');
			},
			'.mobile-nav .sub-menu a ': function() {
				$('#mobile_nav_list').hide();
			},
			'#mobile_nav': function() {
				$('#mobile_nav_list').show();
				return false;
			},
			'#totop': function() {
				body_am(0);
			}
		},
		mouseover: {
			// 当前用户头像
			'.comment-form-submit .avatar,#reply-current-user': function() {
				clearTimeout(cu_timeout);
				$('#reply-current-user').fadeIn('fast');
			},
			'#editor_smilies': function() {
				var smilies = $('#smilies_list').html();
				$(this).tooltip( {title:smilies, trigger:'click', html: true } );
			}
		},
		mouseleave: {
			'.comment-form-submit .avatar,#reply-current-user': function () {
				cu_timeout = setTimeout(function(){$('#reply-current-user').fadeOut('out');},300);
			}
		},
		focus: {
			// 评论表单焦点事件
			'.comment-input input': commentInputFocus
		},
		blur: {
			// 同上
			'.comment-input input': commentInputBlur
		}
	});

	// 顶踩数值增加
	function digg_count (data, type) {
		var digg = type == true ? $('#digg_up') : $('#digg_down');
		if ( data == true) {
			var post_id = digg.attr('data-pid');
			var url = window.location.href;
			var action = type == true ? null : 'Y';
			$.get(url, { post_id: post_id, wpgo_action: 'wpgo_set_like', 'do': action }, function(res){
				digg_count(res, type);
			},'text');
			return false;
		} else {
			if(data == 2){
				alert('你已经表态过啦');
				return false;
			}
			var count = digg.text().match(/(\d+)/);
			count = Number(count[1]) + 1;
			count = digg.text().replace(/\d+/, count);
			digg.text(count);
		}
	}

	// 监听后退与前进事件
	if (history && history.pushState) {
		$(window).on('popstate', function() {
			(location.hash == '') && wpgo_ajax_load(location.href,  true);
		});
	} else {
		// 尼玛的IE，操蛋
		$(window).on('hashchange', function() {
				var url = location.hash;
				if (url.indexOf('#!') != -1) {
					url = url.replace( /^#!/, '' );
				} else if (url == '#' || url == '') {
					url = location.href;
				}
				wpgo_ajax_load(url);
		});
	}
	// 代码高亮
	SyntaxHighlighter.all();

});

// 禁用回复的click事件
var addComment = {
	moveForm : function() {
		return false;
	}
};